
      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      Parameter(NN=80000000)
      
      
      real*8 time(NN)
      real enem(NN),TTime_mat
      integer lxpm(NN),ilaym(NN),icm(NN)

      real*8 tstart(500),tstop(500)
	real*8 tstartu(500),tstopu(500)
      
       character*50 filename,fileout1,fileout2,energy_cha_file
       character*50 fileout1g
       character*50 user_gti_file,fileout,groupfile
        character*1 fj
	character*3 pcu
        character*200 command,enename


        real pha_hist(0:1024,3)

        data pha_hist/3075*0.0/

        
        

       
        character*60 respfile(3)
      character*50 respfilelist
       
      dimension ecmin(2000,3),ecmax(2000,3)
      dimension Nchan_rat(3)

        
        integer*1 ia1
       logical dofft,gtinotfits

        integer status,unit,readwrite,blocksize
      logical anynull,casesan
       real rebin

      
      
       call get_info(filename,pcu,deltat,user_gti_file,fileout
     1  ,ilayer,rebin,respfilelist)

       do j=1,3
          respfile(j)='none'
          Nchan_rat(j)=1
       enddo

       call read_resp(respfile,ecmin,ecmax,Nchan_rat,respfilelist)


       
       IND = 1
       do while (IND .eq. 1)
          IND = index(fileout,' ')
          if(IND .eq. 1)then
             fileout=fileout(IND+1:)
          endif
       enddo


       
       jfile_num=1
      
       call read_data_fits_spec(NN,tstart,tstop,jgti,user_gti_file
     1 ,tstartu,tstopu,jgtiu,gtinotfits,time,nrows,enem,lxpm,ilaym,
     2  icm,filename,jfile_num)

       jgti=1

       if(jgtiu .ne. 0)then
          TTime_mat=0.0
          do j=1,jgtiu
             TTime_mat = TTime_mat+tstopu(j)-tstartu(j)
          enddo
          

       else
        TTime_mat=tstop(1)-tstart(1)
       endif

       

       numgti=1
       

       do j=1,nrows
       if(ilayer .gt. 0 .and. ilayer .ne. ilaym(j))cycle
       times = time(j)-tstart(1)
       if(jgtiu .ne. 0)then
       if(times .gt. tstartu(numgti).and.times .lt. tstopu(numgti))then
          

          icb = (icm(j)-1)/Nchan_rat(lxpm(j))


        pha_hist(icb,lxpm(j)) = pha_hist(icb,lxpm(j)) + 1.0
      
       else
         if(times .gt. tstopu(numgti))then
            if(numgti .lt. jgtiu)numgti=numgti+1
         endif
        
       endif
       else
        icb = (icm(j)-1)/Nchan_rat(lxpm(j))

        pha_hist(icb,lxpm(j)) = pha_hist(icb,lxpm(j)) + 1.0
       endif

       enddo
     
       do jan=1,3

         

       if(jan .eq. 1)fileout1=fileout(:IND-1)//"_10.pha"
       if(jan .eq. 2)fileout1=fileout(:IND-1)//"_20.pha"
       if(jan .eq. 3)fileout1=fileout(:IND-1)//"_30.pha"

       if(jan .eq. 1)fileout1g=fileout(:IND-1)//"_grp_10.pha"
       if(jan .eq. 2)fileout1g=fileout(:IND-1)//"_grp_20.pha"
       if(jan .eq. 3)fileout1g=fileout(:IND-1)//"_grp_30.pha"

          

        IND3 = 1
       do while (IND3 .eq. 1)
          IND3 = index(fileout1,' ')
          if(IND3 .eq. 1)then
             fileout1=fileout1(IND3+1:)
          endif
       enddo

        INDG = 1
       do while (INDG .eq. 1)
          INDG = index(fileout1g,' ')
          if(INDG .eq. 1)then
             fileout1g=fileout1g(INDG+1:)
          endif
       enddo

       
       
       if(rebin .gt. 1e-4 .and. respfile(jan) .ne. 'none')then
       call group_file(ecmin,ecmax,Nchan_rat,fileout1,IND3,groupfile,jan
     1 ,rebin)
       endif
     

       open(unit=20,file='check.pha')

       open(unit=45,file='make_pha')
       Nchan=(1024/Nchan_rat(jan))-1
       do j=0,Nchan
          
          
          
          
          
        write(20,*) j, pha_hist(j,jan)/TTime_mat,
     1  sqrt(pha_hist(j,jan))/TTime_mat


        

       enddo

       if(jan .eq. 1)write(*,*) 'Exposure Time = ',TTime_mat

       
        write(45,*) 'ascii2pha ', 'check.pha ', 
     1  '!',fileout1(:IND3-1),' chanpres=yes dtype=2 qerror=yes rows=-  
     2  tlmin=0 detchans= ',Nchan+1,' telescope=AstroSat instrume=LAXPC 
     3  detnam=',jan*10,' filter=none exposure= ', TTime_mat,
!     4  ' backfile = Bkg_LX30_Jan_level2_err.spec ',
     5 ' respfile = ',respfile(jan)

         
     
       write(45,*)'fparkey',ilayer,' ',fileout1(:IND3-1), 
     1 ' LAYER comm="0 means all Layers"  add="yes"'

       if(rebin .gt. 1e-4 .and. respfile(jan) .ne. 'none')then
        IND4 = 1
       do while (IND4 .eq. 1)
          IND4 = index(groupfile,' ')
          if(IND4 .eq. 1)then
             groupfile=groupfile(IND4+1:)
          endif
       enddo

       write(45,*)'grppha ',fileout1(:IND3-1),' ',fileout1g(:INDG-1), 
     1' comm="GROUP ',groupfile(:IND4-1),'" tempc=exit clobber=yes
     2 chatter=0'
       endif
      
       
    
        close(45)

        command = 'chmod a+x make_pha'

       call  system(command)

       command = './make_pha'

        call  system(command)


              if(jgtiu .ne. 0)then
          IND2 = 1
       do while (IND2 .eq. 1)
          IND2 = index(user_gti_file,' ')
          if(IND2 .eq. 1)then
              user_gti_file= user_gti_file(IND2+1:)
          endif
       enddo
       endif

       if(jgtiu .ne. 0 .and. gtinotfits .and. jan .eq. 1)then
        open(unit=30,file='coldesc.lis')

       write(30,*)'START D  s'
       write(30,*)'STOP D  count/s'
              
       close(30)

       open(unit=30,file='thrash')
       do j=1,jgtiu
          write(30,*) tstartu(j)+tstart(1),tstopu(j)+tstart(1)
       enddo
       close(30)

       

       command="fcreate coldesc.lis "// 'thrash'// 
     1  " "//user_gti_file(:IND2-1)//".fits"//" clobber=yes 
     2 extname=USER_GTI" 

 !      write(*,*) command
       call system(command)
      
       endif

       if(jgtiu .ne. 0)then
           if(gtinotfits)then
           command="fappend "//user_gti_file(:IND2-1)//".fits"//
     1  " "//fileout1(:IND3-1)
           else
           command="fappend "//user_gti_file(:IND2-1)//
     1  " "//fileout1(:IND3-1)
           endif
!           write(*,*) command
           call system(command)
       endif

        command='cphead '//filename//' '//fileout1(:IND3-1)
!         write(*,*) command
          call system(command)

      close(20)
      close(35)
      close(40)
      
      if(rebin .gt. 1e-4 .and. respfile(jan) .ne. 'none')then
      command= 'rm -f thrash coldesc.lis check.pha make_pha '//groupfile
      else
      command= 'rm -f thrash coldesc.lis check.pha make_pha '
      endif
      call system(command)
       
      enddo
      
 
       end




C     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine get_info(filename,pcu,deltat,user_gti_file,fileout
     1,ilayer,rebin,respfilelist)

      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      character*50 filename,fileout,user_gti_file
      character*50 respfilelist
      real rebin
      
      character*3 pcu

      integer    larg,       mxopts
      parameter (larg = 256, mxopts = 64)
*
      integer            iarg, ptr, arglen, nflags, argidx
      logical            done, more, hasarg(mxopts)
      character          flags(mxopts)
      character *(larg)  arg, optarg
*
      common  / gtoptc /
     $     iarg, ptr, arglen, nflags, argidx, done, more, hasarg,
     $     flags, arg, optarg
*
      save / gtoptc /

      integer      status,getopt
        character      flag
        character*300 use_err,statement
        
        logical  argset, first

         filename='level2.event.fits'
         deltat = 1.0
        pcu = 'all'
         fileout = 'spectrum'
        user_gti_file = 'none'
        respfilelist='resp_files'
        ilayer=0
        rebin=0.05

        use_err = '[-u (user gti asci file)] [-o output filename] 
     1-l [layer no]  [-r file having names of response files)] 
     2 -g [energy group fraction] event_file_name'
        use_err = 'USAGE: Fits_spectrum '//use_err

       first = .true.
        argset=.false.
 485    continue

      status=getopt('u:o:l:r:g:',flag,argset,nargs,first)

      if (status .eq. 1) then
         

         if (flag .eq. 'g') then
                      if (argset) then
                    
                    read (optarg, *,err=945) rebin
                   
                    goto 946
 945                continue
                    write(*,*) 'error reading argument for flag g'
                    write(*,*) 'Using default value responsefilelist'
                    goto 9000
 946                continue
                    
                    endif
          endif


           
          if (flag .eq. 'r') then
                      if (argset) then
                    
                    read (optarg, '(A50)',err=955) respfilelist
                   
                    goto 956
 955                continue
                    write(*,*) 'error reading argument for flag u'
                    write(*,*) 'Using default value responsefilelist'
                    goto 9000
 956                continue
                    
                    endif
          endif
          


        

        if (flag .eq. 'u') then
                      if (argset) then
                    
                    read (optarg, '(A50)',err=965) user_gti_file
                   
                    goto 966
 965                continue
                    write(*,*) 'error reading argument for flag u'
                    write(*,*) 'Using default value of no user gti'
                    goto 9000
 966                continue
                    
                    endif
          endif

          if (flag .eq. 'o') then
                      if (argset) then
                    
                    read (optarg, '(A50)',err=975) fileout
                   
                    goto 976
 975                continue
                    write(*,*) 'error reading argument for flag o'
                    write(*,*) 'Using default root of output file'
                    
                    goto 9000
 976                continue
                    
                    endif
          endif

          

                     if (flag .eq. 'l') then
              
                      if (argset) then
                    
                    read (optarg, '(I3)',err=995) ilayer
                    
                    goto 996
 995                continue
                    write(*,*) 'error reading argument for flag l'
                    write(*,*) 'Using default all layers'
                    goto 9000
 996                continue
                    
                    endif
          endif
          
          
          goto 485
        endif

        if (status .lt. 0) then
       write(*,*) use_err
        go to 9000
      else
        if (nargs .eq. 0 .or. argidx .ne. nargs) then
           write(*,*) use_err
          go to 9000
        end if
      end if
             
        call getarg (nargs, filename)
       
       
 9000   continue
        write(*,*) 'Event file being used: ',filename
       
        write(*,*) 'Output file name: ',fileout
        write(*,*) 'User GTI file name: ',user_gti_file
        write(*,*) 'Group energy fraction: ',rebin
        
        if(ilayer .gt. 0 .and. ilayer .lt. 6)then
           write(*,*) "extracting from Layer ", ilayer
        else
           ilayer=0
           write(*,*) "extracting from all layers "
        endif
      end

C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* -*- fortran -*- ------------------------------------------------------
*
*     John W. Eaton
*     jwe@che.utexas.edu
*     Department of Chemical Engineering
*     The University of Texas at Austin
*
*-----------------------------------------------------------------------
*
      integer function getopt (string, flag, argset, nargs, first)
*
      integer        nargs
      character      flag
      character *(*) string
      logical        argset, first
*
*-----------------------------------------------------------------------
*
      integer  stdin, stdout, stderr
*
      parameter ( stdin = 5, stdout = 6, stderr = 0 )

*
      integer    larg,       mxopts
      parameter (larg = 256, mxopts = 64)
*
      integer            iarg, ptr, arglen, nflags, argidx
      logical            done, more, hasarg(mxopts)
      character          flags(mxopts)
      character *(larg)  arg, optarg
*
      common  / gtoptc /
     $     iarg, ptr, arglen, nflags, argidx, done, more, hasarg,
     $     flags, arg, optarg
*
      save / gtoptc /
*
* -- End

*
      integer iargc, lennb, strln, i
*
      if (first) then
*
        first = .false.
*
* -- If the user passes in a character vector for the option string,
* -- he loses.
*
        strln = lennb (string, len (string))
*
        nflags = 0
        i = 1
    1   if (strln .gt. 0) then
          strln = strln - 1
          nflags = nflags + 1
          if (nflags .gt. mxopts) then
            write (stderr, '(a)')
     $           'getopt: too many flags in option list'
            getopt = -1
            return
          end if
          if (string(i:i) .eq. ':') then
            write (stderr, '(a)') 'getopt: garbled option list'
            getopt = -1
            return
          end if
          flags (nflags) = string(i:i)
          i = i + 1
          hasarg(nflags) = (string(i:i) .eq. ':')
          if (hasarg (nflags)) then
            i = i + 1
            strln = strln - 1
          end if
          go to 1
        end if
        done = .false.
        more = .false.
        iarg = 1
        nargs = iargc ()
      end if
*
      if (done) then
        write (stderr, '(a)') 'getopt: no more options'
        argset = .false.
        flag = ' '
        argidx = iarg
        getopt = 0
        return
      end if
*
      if (iarg .gt. nargs) then
        done = .true.
        argset = .false.
        flag = ' '
        argidx = iarg
        getopt = 0
        return
      end if
*
      if (.not. more) then
        call getarg (iarg, arg)
*
* -- Check for explicit end of options.
*
        if (arg .eq. '--') then
          done = .true.
          argset = .false.
          flag = ' '
          iarg = iarg + 1
          argidx = iarg
          getopt = 0
          return
        end if
*
* -- Does the argument match a flag?
*
        if (arg(1:1) .eq. '-') then
          more = .true.
          arglen = lennb (arg, len (arg))
          if (arglen .eq. 1) then
            done = .true.
            argset = .false.
            flag = ' '
            argidx = iarg
            getopt = 0
            return
          end if
          arglen = arglen - 1
          ptr = 2
*
        else
*
* -- End of options implied.
*
          done = .true.
          argset = .false.
          flag = ' '
          argidx = iarg
          getopt = 0
          return
*
        end if
      end if
*
* -- Process flags.
*
      do 10 i = 1, nflags
        if (arg(ptr:ptr) .eq. flags(i)) then
          flag = flags(i)
          if (hasarg(i)) then
            if (iarg .gt. nargs) then
              write (stderr, '(a)') 'getopt: option string missing'
              write (stderr, '(a,a)') 'getopt: option flag is: ', flag
              getopt = -1
              return
            end if
            iarg = iarg + 1
            call getarg (iarg, optarg)
            argset = .true.
          else
            argset = .false.
          end if
          getopt = 1
          go to 9000
        end if
   10 continue
*
      write (stderr, '(a,a)')
     $     'getopt: unrecognized option: -', arg(ptr:ptr)
      getopt = -1
*
 9000 continue
*
      ptr = ptr + 1
      arglen = arglen - 1
      more = (arglen .gt. 0)
      if (.not. more) then
        iarg = iarg + 1
      endif
      argidx = iarg
*
      return
      end
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* -*- fortran -*- ------------------------------------------------------
*
*     John W. Eaton
*     jwe@che.utexas.edu
*     Department of Chemical Engineering
*     The University of Texas at Austin
*
*-----------------------------------------------------------------------
*
      integer function lennb (string, nchmax)
*
      integer       nchmax
      character *1  string(*)
*
*-----------------------------------------------------------------------
*
*     Returns the position of the last non blank character in a
*     characterstring. 
*
*     Parameter list:
*
*       string : Character string for which one desires to find the
*                position of the last non blank character (from the
*                left).
*
*       nchmax : The maximum possible value of the position of the last
*                non blank character in string.  Lennb searches
*                backwards from this location.
*
*-----------------------------------------------------------------------
*
      integer i
*
* -- Begin.
*
      lennb = 0
*
      do 10 i = nchmax, 1, -1
        if (string(i) .ne. ' ') then
          lennb = i
          go to 9000
        end if
   10 continue
*
 9000 continue
*
      return
      end
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++


      subroutine read_data_fits_spec(NN,tstart,tstop,jgti,user_gti_file
     1 ,tstartu,tstopu,jgtiu,gtinotfits,timem,nrowsf,enem,lxpm,ilaym,
     2 icm,filename,jfile_num)


      IMPLICIT DOUBLE PRECISION(a-h,o-z)


     
      
      real*8 tstart(500),tstop(500)
	real*8 tstartu(500),tstopu(500)
      
      character*50 filename,user_gti_file

      

      character*80 errmessage,comment
      logical casesan,gtinotfits
      integer itstart(500),itstop(500)
	integer itstartu(500),itstopu(500)

        integer status,unit,readwrite,blocksize
      logical anynull

      real*8 timem(NN)
      real enem(NN)
      integer lxpm(NN),ilaym(NN),icm(NN)

        casesan=.FALSE.
	

        call read_usergti(user_gti_file,tstartu,tstopu,jgtiu,gtinotfits)
     
 

        
        

         

         



        status=0
      call ftgiou(unit,status)
      if (status .gt. 0)call printerror(status)
      readwrite=0
      call ftopen(unit,filename,readwrite,blocksize,status)
      if (status .gt. 0)then
      call printerror(status)
      write(*,*) 'event file not found'
      write(*,*) filename
      stop
      endif
      

      call FTGKYD(unit,'TSTART',tstart(1),comment,status)
      call FTGKYD(unit,'TSTOP',tstop(1),comment,status)

      if(jgtiu .gt. 0)then
         if(tstartu(1) .gt. tstart(1))then
            do j=1,jgtiu
               tstartu(j) = tstartu(j)-tstart(1)
               tstopu(j) = tstopu(j)-tstart(1)
               
            enddo
         endif
      endif

!      write(*,*) tstart(1),tstop(1)
     

      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)call printerror(status)

      call ftgnrw(unit,nrowsF,status)


      if(nrowsf .gt. NN-1)then
         write(*,*) "no of events too large: ",nrowf
         write(*,*) "taking only: ", NN-1, ' events'
         nrowsf=NN-1
      endif   
   

      irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'Time',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,nrowsf,nullj,timem,anynull
     1 ,status)

        if (status .gt. 0)call printerror(status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'Energy',icol,status)
        call ftgcve(unit,icol,irow,ifelem,nrowsf,nullj,enem,anynull
     1 ,status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'LAXPC_NO.',icol,status)
        call ftgcvj(unit,icol,irow,ifelem,nrowsf,nullj,lxpm,anynull
     1 ,status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'layer',icol,status)
        call ftgcvj(unit,icol,irow,ifelem,nrowsf,nullj,ilaym,anynull
     1 ,status)

         irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'Channel',icol,status)
        call ftgcvj(unit,icol,irow,ifelem,nrowsf,nullj,icm,anynull
     1 ,status)
        
       
        

        if (status .gt. 0)call printerror(status)

       

      

      end

C *************************************************************************
      subroutine printerror(status)

C  This subroutine prints out the descriptive text corresponding to the
C  error status value and prints out the contents of the internal
C  error message stack generated by FITSIO whenever an error occurs.

      integer status
      character errtext*30,errmessage*80

C  Check if status is OK (no error); if so, simply return
      if (status .le. 0)return

C  The FTGERR subroutine returns a descriptive 30-character text string that
C  corresponds to the integer error status number.  A complete list of all
C  the error numbers can be found in the back of the FITSIO User's Guide.
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

C  FITSIO usually generates an internal stack of error messages whenever
C  an error occurs.  These messages provide much more information on the
C  cause of the problem than can be provided by the single integer error
C  status value.  The FTGMSG subroutine retrieves the oldest message from
C  the stack and shifts any remaining messages on the stack down one
C  position.  FTGMSG is called repeatedly until a blank message is
C  returned, which indicates that the stack is empty.  Each error message
C  may be up to 80 characters in length.  Another subroutine, called
C  FTCMSG, is available to simply clear the whole error message stack in
C  cases where one is not interested in the contents.
      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      end do
      end
C *************************************************************************
      subroutine deletefile(filename,status)

C  A simple little routine to delete a FITS file

      integer status,unit,blocksize
      character*(*) filename

C  Simply return if status is greater than zero
      if (status .gt. 0)return

C  Get an unused Logical Unit Number to use to open the FITS file
      call ftgiou(unit,status)

C  Try to open the file, to see if it exists
      call ftopen(unit,filename,1,blocksize,status)

      if (status .eq. 0)then
C         file was opened;  so now delete it 
          call ftdelt(unit,status)
      else if (status .eq. 103)then
C         file doesn't exist, so just reset status to zero and clear errors
          status=0
          call ftcmsg
      else
C         there was some other error opening the file; delete the file anyway
          status=0
          call ftcmsg
          call ftdelt(unit,status)
      end if

C  Free the unit number for later reuse
      call ftfiou(unit, status)
      end
      subroutine read_usergti(user_gti_file,tstartu,tstopu,
     1 jgtiu,gtinotfits)

      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      character*50 user_gti_file

      real*8 tstartu(500),tstopu(500)


      integer status,unit,readwrite,blocksize
      logical anynull
      logical casesan,gtinotfits

       casesan=.FALSE.
       gtinotfits=.true.
          
      	jgtiu=0
	open(unit=33,file=user_gti_file,status='old',err=212)
	
	j=1
213	continue
	read(33,*,err=214,end=212) tstartu(j),tstopu(j)
	jgtiu=j
	j=j+1
	goto 213
 212	continue
        goto 217

 214    continue
        if(jgtiu .eq. 0)then
           status=0
        call ftgiou(unit,status)
      
      readwrite=0
      call ftopen(unit,user_gti_file,readwrite,blocksize,status)

      if(status .gt. 0)return

      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)then
        call printerror(status)
        return
      endif

      call ftgnrw(unit,jgtiu,status)
         
      irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'START',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,jgtiu,nullj,tstartu,anynull
     1 ,status)

        irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'STOP',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,jgtiu,nullj,tstopu,anynull
     1 ,status)

        
         if (status .gt. 0)then
        call printerror(status)
        jgtiu=0
        return
         endif
        
         gtinotfits=.false.

      endif

 217  continue

      

        end

      subroutine read_resp(respfile,ecmin,ecmax,Nchan,respfilelist)

      implicit real*8(a-h,o-z)

       character*60 respfile(3)
      character*50 respfilelist
       
      dimension ecmin(2000,3),ecmax(2000,3),emin(2000),emax(2000)
      dimension Nchan(3)
      

      integer status,unit,readwrite,blocksize
      logical anynull,casesan

      casesan=.FALSE.

      
      open(unit=47,err=707,file=respfilelist,status='old')
 705  continue
      read(47,*,end=706) lxp,respfile(lxp)
       
      
      status=0
      call ftgiou(unit,status)
      if (status .gt. 0)call printerror(status)
      readwrite=0
      call ftopen(unit,respfile(lxp),readwrite,blocksize,status)
      if (status .gt. 0)call printerror(status)
      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)call printerror(status)
      
       call FTGCNO(unit,casesan,'E_min',icol,status)
      
       if (status .gt. 0)then
          ntable = ntable+1
           call ftmahd(unit,ntable,hdutype,status)
           call FTGCNO(unit,casesan,'E_min',icol,status)
        if (status .gt. 0)call printerror(status)
        endif

        call ftgnrw(unit,nrows,status)
        
        irow=1
        ifelem=1
        call ftgcvd(unit,icol,irow,ifelem,nrows,nullj,emin,anynull
     1 ,status)

       
        call FTGCNO(unit,casesan,'E_max',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,nrows,nullj,emax,anynull
     1 ,status)
        
        Nchan(lxp) = 1024/nrows
        do j=1,nrows
          
           ecmin(j,lxp)=emin(j)
           ecmax(j,lxp)=emax(j)
        enddo   
       
        if(status .eq. 0)then
           write(*,*) 'Obtained energy information for laxpc ',lxp*10,
     1' using ',respfile(lxp)
        endif
        call ftclos(unit, status)
        call ftfiou(unit, status)

        goto 705
706    continue
       goto 708
 707    continue
        write(*,*) 'No response file and hence no energy information'
 708    continue
       

        end

      subroutine group_file(emin,emax,Nchan_rat,fileout,IND,groupfile
     1 ,jan,rebin)

      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      dimension emin(2000,3),emax(2000,3)
      dimension Nchan_rat(3)
      real rebin

      character*50 fileout,groupfile

      groupfile=fileout(:IND-1)//"_grpfile"
      
     
 
       open(unit=20,file=groupfile)
     

      jmax =1024/Nchan_rat(jan)
      
      
      j=1
      jl = j-1
      jh = j-1
      emina = emin(1,jan)
      
         emaxa = emax(j,jan)

 30      continue
       Q = (emaxa-emina)/((emaxa+emina)/2.0)
       if(Q .gt. rebin .and. emax(j,jan) .gt. 3.0)then
!          write(*,*) jl,jh,jh-jl+1, emina,emaxa,j
           write(20,*) jl,jh,jh-jl+1
          j=j+1
          emina = emin(j,jan)
          emaxa = emax(j,jan)
          jl = j-1
          jh = j-1
       else
          j=j+1
          emaxa = emax(j,jan)
          jh = j-1
       endif
       if(j .lt. jmax)goto 30   
      end
